import pygame
import random

#Why won't the bubbles work????? !!!!!

# Set up the bubble brain
#class Bubble():
    # Bubble class constructor funtion
#    def __init__(self, x, y):
        # Make some variables for the Bubble
#        self.x = x
#        self.y = y
#        self.speed = random.randint(1, 3)
#        self.pic = pygame.image.load("../assets/Bubble.png")
#        self.on_screeen = True

        # Shrink the Bubble pic
#        self.pic = pygame.transform.scale(self.pic, (15, 15))

    # Bubble update function
#    def update(self, screen):
#        self.y -= self.speed
#        screen.blit(self.pic, (self.x, self.y))

#        if self.y < -self.pic.get_height():
#            self.on_screen = False
            
# End of Bubble class

# Set up the Enemy's brain
class Enemy():
    # Enemy constructor function
    def __init__(self, x, y, speed, size):
        # Make the Enemy's variables
        self.x = x
        self.y = y
        self.type = random.randint(0, 4)
        if self.type == 0:
            self.pic = pygame.image.load("../assets/Fish04_A.png")
            self.pic2 = pygame.image.load("../assets/Fish04_B.png")
        if self.type == 1:
            self.pic = pygame.image.load("../assets/Fish02_A.png")
            self.pic2 = pygame.image.load("../assets/Fish02_B.png")
        if self.type == 2:
           self.pic = pygame.image.load("../assets/Fish03_A.png")
           self.pic2 = pygame.image.load("../assets/Fish03_B.png")
        if self.type == 3:
            self.pic = pygame.image.load("../assets/Shark_A.png")
            self.pic2 = pygame.image.load("../assets/Shark_B.png")
        if self.type == 4:
            self.pic = pygame.image.load("../assets/Mongoose_A.png")
            self.pic2 = pygame.image.load("../assets/Mongoose_B.png")
        self.speed = speed
        self.size = size
        self.hitbox = pygame.Rect(self.x, self.y, int(self.size*1.25), self.size)
        self.animation_timer_max = 16
        self.animation_timer = self.animation_timer_max
        self.animation_frame = 0

       # Shrink the enemy pic
        self.pic = pygame.transform.scale(self.pic, (int(self.size*1.25), self.size))
        self.pic2 = pygame.transform.scale(self.pic2, (int(self.size*1.25), self.size))

        # Flip the pic if the enemy is moving left
        if self.speed < 0:
            self.pic = pygame.transform.flip(self.pic, True, False)
            self.pic2 = pygame.transform.flip(self.pic2, True, False)

    # Enemy update function (stuff to happen over and over agaim)
    def update (self, screen):
        self.animation_timer -= 1
        if self.animation_timer <= 0:
            self.animation_timer = self.animation_timer_max
            self.animation_frame += 1
            if self.animation_frame > 1:
                self.animation_frame = 0
        self.x += self.speed
        self.hitbox.x += self.speed
        #pygame.draw.rect(screen, (255, 0, 255), self.hitbox)
        if self.animation_frame == 0:
            screen.blit(self.pic, (self.x, self.y))
        else:
            screen.blit(self.pic2, (self.x, self.y))
        
# End of Enemy class

# Start the game
pygame.init()
game_width = 1000
game_height = 650
screen = pygame.display.set_mode((game_width, game_height))
clock = pygame.time.Clock()
running = True

#Load all the pictures for our game
background_pic = pygame.image.load("../assets/Scene_A.png")
background_pic2 = pygame.image.load("../assets/Scene_B.png")
player_pic = pygame.image.load("../assets/Water_Bear1.png")
player_pic2 = pygame.image.load("../assets/Water_Bear2.png")
player_eating_pic = pygame.image.load("../assets/Water_Bear_open.png")

# Make some variables for the background animation
bg_animation_timer_max = 25
bg_animation_timer = bg_animation_timer_max
bg_animation_frame = 0

#Make some variables for our player
player_starting_x = 480 
player_starting_y = 310
player_starting_size = 30
player_x = player_starting_x
player_y = player_starting_y
player_speed = 0.3
player_speed_x = 0
player_speed_y = 0
player_size = player_starting_size
player_facing_left = False
player_hitbox = pygame.Rect(player_x, player_y, int(player_size*1.25), player_size)
player_alive = False

# Make some variables for the player animation
player_eating_timer_max = 8
player_eating_timer = 0
player_swimming_timer_max = 12
player_swimming_timer = player_swimming_timer_max
player_swimming_frame = 0

# Make some variables for the HUD (heads=up display)
score = -1
score_font = pygame.font.SysFont("default", 30)
score_text = score_font.render("Score:" +str(score), 1, (25, 255, 255))
play_button_pic = pygame.image.load("../assets/BtnPlay.png")
play_button_x = game_width/2 - play_button_pic.get_width()/2
play_button_y = game_height/2 - play_button_pic.get_height()/2 +30
title_pic = pygame.image.load("../assets/title.png")
title_x = game_width/2 - title_pic.get_width()/2
title_y = play_button_y - 320

# Make the enemy spawning timer variables
enemy_timer_max = 40
enemy_timer = enemy_timer_max

# Make the enemies array |Enemy(x, y, speed, size) [see line 6]
enemies = []
enemies_to_remove = []

# Make the bubbles array and timer stuff
#bubbles = []
#bubbles_to_remove = []
#bubble_timer = 0

# ***************** Loop Land Below *****************
# Everything under 'while running' will be repeated over and over again
while running:
    # Makes the game stop if the player clicks the X or presses esc
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            running = False
        if event.type == pygame.KEYDOWN and event.key == pygame.K_ESCAPE:
            running = False

    # Check to see what keys the player is pressing
        #Or: player_x = player_x - 1
    keys = pygame.key.get_pressed()
    if keys [pygame.K_RIGHT]:
        player_speed_x += player_speed
    if keys [pygame.K_LEFT]:
         player_speed_x -= player_speed
    if keys [pygame.K_DOWN]:
         player_speed_y += player_speed
    if keys [pygame.K_UP]:
        player_speed_y -= player_speed
    #if keys [pygame.K_SPACE]:
     #   player_size += 2

    # Make the player slow down over time
    if player_speed_x > 1:
        player_speed_x -= 0.1
    if player_speed_x < -1:
        player_speed_x += 0.1
    if player_speed_y > 1:
        player_speed_y -= 0.1
    if player_speed_y < -1:
        player_speed_y  += 0.1

    # Move the player
    player_x += player_speed_x
    player_y += player_speed_y

    # Figure out whether or not to flip the player
    if player_speed_x > 0:
        player_facing_left = False
    else:
        player_facing_left = True

    # Stop the player from leaving the screen
    if player_x < 0:
        player_x = 0
        player_speed_x = 0
    if player_x > game_width - player_size*1.25:
        player_x = game_width - player_size*1.25
        player_speed_x = 0
    if player_y < 0:
        player_y = 0
        player_speed_y = 0
    if player_y > game_height - player_size:
        player_y = game_height - player_size
        player_speed_y = 0

    # Do the background animation timer
    bg_animation_timer -= 1
    if bg_animation_timer <= 0:
        bg_animation_frame += 1
        if bg_animation_frame > 1:
            bg_animation_frame = 0
        bg_animation_timer = bg_animation_timer_max

    if bg_animation_frame == 0:
        screen.blit(background_pic, (0, 0))
    else:
        screen.blit(background_pic2, (0, 0))

    # Spawn a new enemy whenever enemy_timer hits 0
    enemy_timer -= 1
    if enemy_timer <= 0:
        new_enemy_y = random.randint(0, game_height)
        new_enemy_speed = random.randint(2, 6)
        new_enemy_size = random.randint(player_size/2, player_size*2)
        if random.randint(0, 1) == 0:
            enemies.append(Enemy(-new_enemy_size*2, new_enemy_y, new_enemy_speed, new_enemy_size))
        else:
            enemies.append(Enemy(game_width, new_enemy_y, -new_enemy_speed, new_enemy_size))
        enemy_timer = enemy_timer_max

    for enemy in enemies_to_remove:
        enemies.remove(enemy)
    enemies_to_remove = []

    # Update all the enemies
    for enemy in enemies:
        enemy.update(screen)
        if enemy.x < -1000 or enemy.x > game_width+1000:
            enemies_to_remove.append(enemy)

    # Make a new bubble when the bubble timer reaches 0
#    bubble_timer -= 1
#    if bubble_timer <= 0 and player_alive:
#        if player_facing_left:
#            bubbles.append(Bubble(player_x, player_y))
#        else:
#            bubbles.append(Bubble(player_x + player_size*1.25, player_y))
#        bubble_timer = random.randint(40, 90)

    # Update all the bubbles
#    for bubble in bubbles:
#        if bubble.on_screen:
#            bubble.update(screen)
#        else:
#            bubbles_to_remove.append(bubble)

    # Remove the bubbles in bubbles_to_remove
#    for bubble in bubbles_to_remove:
#        bubbles.remove(bubble)
#    bubbles_to_remove = []

    if player_alive:
        # Update the player hitbox
        player_hitbox.x = player_x
        player_hitbox.y = player_y
        player_hitbox.width = int(player_size * 1.25)
        player_hitbox.height = player_size
        #pygame.draw.rect(screen, (255, 255, 255), player_hitbox)

        # Check to see when the player hits and enemy
        for enemy in enemies:
            if player_hitbox.colliderect(enemy.hitbox):
                if player_size >= enemy.size:
                    score += enemy.size
                    player_size += 2
                    enemies.remove(enemy)
                    player_eating_timer = player_eating_timer_max
                else:
                    player_alive = False

        # Do the player swimming animation timer
        player_swimming_timer -= 1
        if player_swimming_timer <= 0:
            player_swimming_timer = player_swimming_timer_max
            player_swimming_frame += 1
            if player_swimming_frame > 1:
                player_swimming_frame = 0
            
        # Draw the player pic
        if player_eating_timer > 0:
            player_pic_small = pygame.transform.scale(player_eating_pic, (int(player_size*1.25), player_size))
            player_eating_timer -= 1
        else:
            if player_swimming_frame == 0:
                player_pic_small = pygame.transform.scale(player_pic, (int(player_size*1.25), player_size))
            else:
                player_pic_small = pygame.transform.scale(player_pic2, (int(player_size*1.25), player_size))
        if player_facing_left:
            player_pic_small = pygame.transform.flip(player_pic_small, True, False)
        screen.blit(player_pic_small, (player_x, player_y))

    # Draw the score text
    if player_alive:
        score_text = score_font.render("Score: "+str(score), 1, (255, 255, 255))
    else:
        score_text = score_font.render("Final Score: "+str(score), 1, (255, 255, 255))
    if score >= 0:
        screen.blit(score_text, (40, 40))

    # Draw the menu (when the player is not alive)
    if not player_alive:
        screen.blit(play_button_pic, (play_button_x, play_button_y))
        screen.blit(title_pic, (title_x, title_y))
        mouse_x, mouse_y = pygame.mouse.get_pos()
        # Check to see if the player clicks the play button
        if pygame.mouse.get_pressed()[0]:
            if mouse_x > play_button_x and mouse_x < play_button_x+play_button_pic.get_width():
                if mouse_y > play_button_y and mouse_y < play_button_y+play_button_pic.get_height():
                    # Restart the game
                    player_alive = True
                    score = 0
                    player_x = player_starting_x
                    player_y = player_starting_y
                    player_size = player_starting_size
                    player_speed_x = 0
                    player_speed_y = 0
                    for enemy in enemies:
                        enemies_to_remove.append(enemy)

                    #for enemy in enemies: #enemies.remove(enemy) --won't work
    # Tell pygame to update the screen
    pygame.display.flip()
    clock.tick(50)
    pygame.display.set_caption("Help Water Bear Survive!   fps: " + str(clock.get_fps()))

    # Use this in shell to view fonts:
        # import pygame
        # pygame.font.get_fonts()
